#!/usr/bin/python

from urlparse import urlparse, urlunsplit
import dav

class IWebDav():

  def __init__(self):
    self.connection = None
    self.url = ""
    self.resource = None

  def setURI(self, uri):
  
    scheme, server, path, params, query, fragment = urlparse(uri)
    
    # Get username and pass from 'server'
    try:
      i = server.rindex('@')
    except:
      # flag this condition as "no auth"
      user = None
      pw = None
    else:
      # rindex didn't raise an exception
      try:
        user_end = server[:i].index(':')
      except:
        user = server[:i]
        pw = ""
      else:
        # index didn't raise an exception
        user = server[:user_end]
        pw = server[user_end+1:i]
      finally:
        server = server[i+1:]
    
    if scheme == "https":
      self.connection = dav.DAVSConnection(server)
    elif scheme == "http":
      self.connection = dav.DAVConnection(server)
    else:
      self.connection = None
      return False

    if user:
      self.connection.set_auth(user, pw)
    
    print "User: %s, Pass: %s" % (user, pw)
    self.url = urlunsplit((scheme, server, path, params, query))

    print "Connection:"
    print self.connection
    
    print "URL: %s" % self.url
    try:
      self.resource = dav.DAVCollection(self.url, self.connection)
    except dav.davresource.DAVError:
      print "Bad URL"
      return False
    except TypeError:
      print "Bad username or password"
      return False
    
    self.resource.update()
    
    if self.resource._result == None:
      self.resource = None
      return False
    
    return True


  def getChildren(self):
  
    return self.resource.get_child_names():


  def getAllCalendars(self):
  
    print "Getting all calendars"
    for cal in self.resource.get_child_objects():
      print cal.get().read()


wd = IWebDav()
user="nixphoeni@gmail.com"

#wd.setURI("www.google.com", 443, True, user, "redgold")
#wd.setLocation("/calendar/dav/%s/events" % user)
if wd.setURI("https://%s:%s@www.google.com/calendar/dav/%s/events/" % (user, "redgold", user)):
  print "Children:"
  print wd.getChildren()
  
  wd.getAllCalendars()
